package com.microservices.pms.project.mapper;

import com.microservices.pms.project.domain.PmsProjectTestcase;
import com.microservices.pms.project.domain.vo.PmsProjectTestcaseBatchUpdateVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;

/**
 * 测试用例管理Mapper接口
 *
 * @author otto
 * @date 2023-11-22
 */
@Mapper
public interface PmsProjectTestcaseMapper {
    /**
     * 查询测试用例管理
     *
     * @param id 测试用例管理主键
     * @return 测试用例管理
     */
    public PmsProjectTestcase selectPmsProjectTestcaseById(Long id);

    /**
     * 查询测试用例管理列表
     *
     * @param pmsProjectTestcase 测试用例管理
     * @return 测试用例管理集合
     */
    public List<PmsProjectTestcase> selectPmsProjectTestcaseList(PmsProjectTestcase pmsProjectTestcase);

    public List<PmsProjectTestcase> selectPmsProjectTestcaseForTestsheetList(PmsProjectTestcase pmsProjectTestcase);

    public List<PmsProjectTestcase> selectPmsProjectTestcaseForSelectList(PmsProjectTestcase pmsProjectTestcase);

    /**
     * 新增测试用例管理
     *
     * @param pmsProjectTestcase 测试用例管理
     * @return 结果
     */
    public int insertPmsProjectTestcase(PmsProjectTestcase pmsProjectTestcase);

    /**
     * 修改测试用例管理
     *
     * @param pmsProjectTestcase 测试用例管理
     * @return 结果
     */
    public int updatePmsProjectTestcase(PmsProjectTestcase pmsProjectTestcase);

    /**
     * 删除测试用例管理
     *
     * @param id 测试用例管理主键
     * @return 结果
     */
    public int deletePmsProjectTestcaseById(Long id);

    /**
     * 批量删除测试用例管理
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deletePmsProjectTestcaseByIds(Long[] ids);

    /**
     * 获取当前项目下测试用例的最大索引值
     *
     * @param pmsProjectId 项目ID
     * @return 最大索引值
     */
    Long selectPmsProjectTestcaseMaxIndexByProjectId(Long pmsProjectId);

    /**
     * 查询测试用例数量
     *
     * @param pmsProjectTestcase 查询条件
     * @return 测试用例数量
     */
    Integer selectPmsProjectTestcaseCount(PmsProjectTestcase pmsProjectTestcase);

    /**
     * 设置测试用例模块为空
     *
     * @param moduleId        模块Id
     * @param currentUsername 当前用户
     * @param nowDate         当前时间
     */
    void updatePmsProjectTestcaseToNoModule(@Param("moduleId") Long moduleId, @Param("currentUsername") String currentUsername, @Param("nowDate") Date nowDate);

    /**
     * 评论更新测试用例
     *
     * @param pmsProjectTestcaseBatchUpdateVo 更新内容
     * @return 更新结果
     */
    int batchUpdatePmsProjectTestcase(PmsProjectTestcaseBatchUpdateVo pmsProjectTestcaseBatchUpdateVo);

    Long[] selectPmsProjectTestcaseIdsByTestSheetIds(@Param("testSheetIds") Long[] testSheetIds);

    /**
     * 检查批量更新的测试用例是否属于同一个项目
     *
     * @param idList id列表
     * @return 项目Id列表
     */
    List<Long> selectProjectIdListInTestcaseIdList(@Param("idList") List<Long> idList);

    int deletePmsProjectTestcaseByProjectId(@Param("projectId") Long projectId);
}
